#include once "inc/clientlib.bi"
#include once "inc/public_errors.bi"

#ifndef NULL
#define NULL cptr(any ptr,0) 
#endif

sub MyonServerProtocolVersionEvent           cdecl (serverConnectionHandlerID as uint64, protocolVersion as integer)
  print "MyonServerProtocolVersionEvent: " & protocolVersion
end sub

sub MyonNewChannelEvent                      cdecl (serverConnectionHandlerID as uint64, channelID as uint64, channelParentID as uint64)
  print "MyonNewChannelEvent: " & channelID
end sub

sub MyonNewChannelCreatedEvent               cdecl (serverConnectionHandlerID as uint64, channelID as uint64, channelParentID as uint64, invokerID as anyID, invokerName as const zstring ptr, invokerUniqueIdentifier as const zstring ptr)
  print "MyonNewChannelCreatedEvent: "
end sub

sub MyonDelChannelEvent                      cdecl (serverConnectionHandlerID as uint64, channelID as uint64, invokerID as anyID, invokerName as const zstring ptr, invokerUniqueIdentifier as const zstring ptr)
  print "MyonDelChannelEvent: "
end sub

sub MyonChannelMoveEvent                     cdecl (serverConnectionHandlerID as uint64, channelID as uint64, newChannelParentID as uint64, invokerID as anyID, invokerName as const zstring ptr, invokerUniqueIdentifier as const zstring ptr)
  print "MyonChannelMoveEvent: "
end sub

sub MyonUpdateChannelEvent                   cdecl (serverConnectionHandlerID as uint64, channelID as uint64)
  print "MyonUpdateChannelEvent: "
end sub

sub MyonUpdateChannelEditedEvent             cdecl (serverConnectionHandlerID as uint64, channelID as uint64, invokerID as anyID, invokerName as const zstring ptr, invokerUniqueIdentifier as const zstring ptr)
  print "MyonUpdateChannelEditedEvent: "
end sub

sub MyonUpdateClientEvent                    cdecl (serverConnectionHandlerID as uint64, clientID as anyID, invokerID as anyID, invokerName as const zstring ptr, invokerUniqueIdentifier as const zstring ptr)
  print "MyonUpdateClientEvent: "
end sub

sub MyonClientMoveEvent                      cdecl (serverConnectionHandlerID as uint64, clientID as anyID, oldChannelID as uint64,newChannelID as uint64, visibility as integer, moveMessage as const zstring ptr)
  print "MyonClientMoveEvent: "
end sub

sub MyonClientMoveSubscriptionEvent          cdecl (serverConnectionHandlerID as uint64, clientID as anyID, oldChannelID as uint64,newChannelID as uint64, visibility as integer)
  print "MyonClientMoveSubscriptionEvent: " & oldChannelID,newChannelID
end sub

sub MyonClientMoveTimeoutEvent               cdecl (serverConnectionHandlerID as uint64, clientID as anyID, oldChannelID as uint64,newChannelID as uint64, visibility as integer, timeoutMessage as const zstring ptr)
  print "MyonClientMoveTimeoutEvent: "
end sub

sub MyonClientMoveMovedEvent                 cdecl (serverConnectionHandlerID as uint64, clientID as anyID, oldChannelID as uint64,newChannelID as uint64, visibility as integer, moverID  as anyID, moverName as const zstring ptr, moverUniqueIdentifier as const zstring ptr, moveMessage as const zstring ptr)
  print "MyonClientMoveMovedEvent: "
end sub

sub MyonClientKickFromChannelEvent           cdecl (serverConnectionHandlerID as uint64, clientID as anyID, oldChannelID as uint64,newChannelID as uint64, visibility as integer, kickerID as anyID, kickerName as const zstring ptr, kickerUniqueIdentifier as const zstring ptr, kickMessage as const zstring ptr)
  print "MyonClientKickFromChannelEvent: "
end sub

sub MyonClientKickFromServerEvent            cdecl (serverConnectionHandlerID as uint64, clientID as anyID, oldChannelID as uint64,newChannelID as uint64, visibility as integer, kickerID as anyID, kickerName as const zstring ptr, kickerUniqueIdentifier as const zstring ptr, kickMessage as const zstring ptr)
  print "MyonClientKickFromServerEvent: "
end sub

sub MyonClientIDsEvent                       cdecl (serverConnectionHandlerID as uint64, uniqueClientIdentifier as const zstring ptr, clientID as anyID, clientName as const zstring ptr)
  print "MyonClientIDsEvent: "
end sub

sub MyonClientIDsFinishedEvent               cdecl (serverConnectionHandlerID as uint64)
  print "MyonClientIDsFinishedEvent: "
end sub

sub MyonServerEditedEvent                    cdecl (serverConnectionHandlerID as uint64, editerID as anyID, editerName as const zstring ptr, editerUniqueIdentifier as const zstring ptr)
  print "MyonServerEditedEvent: "
end sub

sub MyonServerUpdatedEvent                   cdecl (serverConnectionHandlerID as uint64)
  print "MyonServerUpdatedEvent: "
end sub

sub MyonServerErrorEvent                     cdecl (serverConnectionHandlerID as uint64, errorMessage as const zstring ptr, errorcode as uinteger, returnCode as const zstring ptr, extraMessage as const zstring ptr)
  print "MyonServerErrorEvent: "
end sub

sub MyonServerStopEvent                      cdecl (serverConnectionHandlerID as uint64, shutdownMessage as const zstring ptr)
  print "MyonServerStopEvent: " & *shutdownMessage
end sub

sub MyonTextMessageEvent                     cdecl (serverConnectionHandlerID as uint64, targetMode as anyID, toID as anyID, fromID as anyID, fromName as const zstring ptr, fromUniqueIdentifier as const zstring ptr, message as const zstring ptr)
  print "MyonTextMessageEvent: "  
end sub

sub MyonTalkStatusChangeEvent                cdecl (serverConnectionHandlerID as uint64, status as integer, isReceivedWhisper as integer, clientID as anyID)
  print "MyonTalkStatusChangeEvent: "
end sub

sub MyonIgnoredWhisperEvent                  cdecl (serverConnectionHandlerID as uint64, clientID as anyID)
  print "MyonIgnoredWhisperEvent: "
end sub

sub MyonConnectionInfoEvent                  cdecl (serverConnectionHandlerID as uint64, clientID as anyID)
  print "MyonConnectionInfoEvent: "
end sub

sub MyonServerConnectionInfoEvent            cdecl (serverConnectionHandlerID as uint64)
  print "MyonServerConnectionInfoEvent: "
end sub

sub MyonChannelSubscribeEvent                cdecl (serverConnectionHandlerID as uint64, channelID as uint64)
  print "MyonChannelSubscribeEvent: "
end sub

sub MyonChannelSubscribeFinishedEvent        cdecl (serverConnectionHandlerID as uint64)
  print "MyonChannelSubscribeFinishedEvent: "
end sub

sub MyonChannelUnsubscribeEvent              cdecl (serverConnectionHandlerID as uint64, channelID as uint64)
  print "MyonChannelUnsubscribeEvent: "
end sub

sub MyonChannelUnsubscribeFinishedEvent      cdecl (serverConnectionHandlerID as uint64)
  print "MyonChannelUnsubscribeFinishedEvent: "
end sub

sub MyonChannelDescriptionUpdateEvent        cdecl (serverConnectionHandlerID as uint64, channelID as uint64)
  print "MyonChannelDescriptionUpdateEvent: "
end sub

sub MyonChannelPasswordChangedEvent          cdecl (serverConnectionHandlerID as uint64, channelID as uint64)
  print "MyonChannelPasswordChangedEvent: "
end sub

sub MyonPlaybackShutdownCompleteEvent        cdecl (serverConnectionHandlerID as uint64)
  print "MyonPlaybackShutdownCompleteEvent: "
end sub

sub MyonSoundDeviceListChangedEvent          cdecl (modeID as const zstring ptr, playOrCap as integer)
  print "MyonSoundDeviceListChangedEvent: "
end sub

sub MyonEditPlaybackVoiceDataEvent           cdecl (serverConnectionHandlerID as uint64, clientID as anyID, samples as short ptr, sampleCount as integer, channels as integer)
  print "MyonEditPlaybackVoiceDataEvent: "
end sub

sub MyonEditPostProcessVoiceDataEvent        cdecl (serverConnectionHandlerID as uint64, clientID as anyID, samples as short ptr, sampleCount as integer, channels as integer, channelSpeakerArray as const uinteger ptr, channelFillMask as uinteger ptr)
  print "MyonEditPostProcessVoiceDataEvent: "
end sub

sub MyonEditMixedPlaybackVoiceDataEvent      cdecl (serverConnectionHandlerID as uint64, samples as short ptr, sampleCount as integer, channels as integer, channelSpeakerArray as const uinteger ptr, channelFillMask as uinteger ptr)
  print "MyonEditMixedPlaybackVoiceDataEvent: "
end sub

sub MyonEditCapturedVoiceDataEvent           cdecl (serverConnectionHandlerID as uint64, samples as short ptr, sampleCount as integer, channels as integer, edited as integer ptr)
  print "MyonEditCapturedVoiceDataEvent: "
end sub

sub MyonCustom3dRolloffCalculationClientEvent cdecl (serverConnectionHandlerID as uint64, clientID as anyID, distance as single, volume as single ptr)
  print "MyonCustom3dRolloffCalculationClientEvent: "
end sub

sub MyonCustom3dRolloffCalculationWaveEvent  cdecl (serverConnectionHandlerID as uint64, waveHandle as uint64, distance as single, volume as single ptr)
  print "MyonCustom3dRolloffCalculationWaveEvent: "
end sub

sub MyonUserLoggingMessageEvent              cdecl (logmessage as const zstring ptr, logLevel as integer, logChannel as const zstring ptr, logID as uint64, logTime as const zstring ptr, completeLogString as const zstring ptr)
  print "MyonUserLoggingMessageEvent logTime " & *logTime 
  print "message: " & *logmessage
  print
end sub

sub MyonCustomPacketEncryptEvent             cdecl (dataToSend as zstring ptr ptr, sizeOfData as uinteger ptr)
end sub

sub MyonCustomPacketDecryptEvent             cdecl (dataReceived as zstring ptr ptr, dataReceivedSize as uinteger ptr)
end sub

sub MyonProvisioningSlotRequestResultEvent   cdecl (errorcode as uinteger, requestHandle as uint64, connectionKey as const zstring ptr)
  print "MyonProvisioningSlotRequestResultEvent: "
end sub

'
' main
'
dim as ClientUIFunctions MyClientCallbacks


with MyClientCallbacks 
  .onServerProtocolVersionEvent            = @MyonServerProtocolVersionEvent
  .onNewChannelEvent                       = @MyonNewChannelEvent
  .onNewChannelCreatedEvent                = @MyonNewChannelCreatedEvent
  .onDelChannelEvent                       = @MyonDelChannelEvent
  .onChannelMoveEvent                      = @MyonChannelMoveEvent
  .onUpdateChannelEvent                    = @MyonUpdateChannelEvent
  .onUpdateChannelEditedEvent              = @MyonUpdateChannelEditedEvent
  .onUpdateClientEvent                     = @MyonUpdateClientEvent
  .onClientMoveEvent                       = @MyonClientMoveEvent
  .onClientMoveSubscriptionEvent           = @MyonClientMoveSubscriptionEvent
  .onClientMoveTimeoutEvent                = @MyonClientMoveTimeoutEvent
  .onClientMoveMovedEvent                  = @MyonClientMoveMovedEvent
  .onClientKickFromChannelEvent            = @MyonClientKickFromChannelEvent
  .onClientKickFromServerEvent             = @MyonClientKickFromServerEvent
  .onClientIDsEvent                        = @MyonClientIDsEvent
  .onClientIDsFinishedEvent                = @MyonClientIDsFinishedEvent
  .onServerEditedEvent                     = @MyonServerEditedEvent
  .onServerUpdatedEvent                    = @MyonServerUpdatedEvent
  .onServerErrorEvent                      = @MyonServerErrorEvent
  .onServerStopEvent                       = @MyonServerStopEvent
  .onTextMessageEvent                      = @MyonTextMessageEvent
  .onTalkStatusChangeEvent                 = @MyonTalkStatusChangeEvent
  .onIgnoredWhisperEvent                   = @MyonIgnoredWhisperEvent
  .onConnectionInfoEvent                   = @MyonConnectionInfoEvent
  .onServerConnectionInfoEvent             = @MyonServerConnectionInfoEvent
  .onChannelSubscribeEvent                 = @MyonChannelSubscribeEvent
  .onChannelSubscribeFinishedEvent         = @MyonChannelSubscribeFinishedEvent
  .onChannelUnsubscribeEvent               = @MyonChannelUnsubscribeEvent
  .onChannelUnsubscribeFinishedEvent       = @MyonChannelUnsubscribeFinishedEvent
  .onChannelDescriptionUpdateEvent         = @MyonChannelDescriptionUpdateEvent
  .onChannelPasswordChangedEvent           = @MyonChannelPasswordChangedEvent
  .onPlaybackShutdownCompleteEvent         = @MyonPlaybackShutdownCompleteEvent
  .onSoundDeviceListChangedEvent           = @MyonSoundDeviceListChangedEvent
  .onEditPlaybackVoiceDataEvent            = @MyonEditPlaybackVoiceDataEvent
  .onEditPostProcessVoiceDataEvent         = @MyonEditPostProcessVoiceDataEvent
  .onEditMixedPlaybackVoiceDataEvent       = @MyonEditMixedPlaybackVoiceDataEvent
  .onEditCapturedVoiceDataEvent            = @MyonEditCapturedVoiceDataEvent
  .onCustom3dRolloffCalculationClientEvent = @MyonCustom3dRolloffCalculationClientEvent
  .onCustom3dRolloffCalculationWaveEvent   = @MyonCustom3dRolloffCalculationWaveEvent
  .onUserLoggingMessageEvent               = @MyonUserLoggingMessageEvent
  .onCustomPacketEncryptEvent              = NULL '@MyonCustomPacketEncryptEvent
  .onCustomPacketDecryptEvent              = NULL '@MyonCustomPacketDecryptEvent
  .onProvisioningSlotRequestResultEvent    = @MyonProvisioningSlotRequestResultEvent
end with

if ts3client_initClientLib(@MyClientCallbacks, NULL, LogType_USERLOGGING,NULL,"./") then
  print "error: initClientLib() !"
  beep:sleep:end 1
end if

dim as uint64 ConnectionID
if ts3client_spawnNewServerConnectionHandler(0,@ConnectionID) then
  print "error: spawnNewServerConnectionHandler() !"
  ts3client_destroyClientLib
  beep:sleep:end 1
end if
print "ConnectionID " & ConnectionID

dim as zstring ptr Identity
if ts3client_createIdentity(@Identity) then
  print "error: createIdentity() !"
  ts3client_destroyServerConnectionHandler ConnectionID
  ts3client_destroyClientLib
  beep:sleep:end 1
end if
print "Identity: " & *Identity

if ts3client_startConnection(ConnectionID,Identity,"192.168.0.4",9987,"a_nickname",NULL,"","") then
  print "error: startConnection() !"
  ts3client_freeMemory Identity
  ts3client_destroyServerConnectionHandler ConnectionID
  ts3client_destroyClientLib
end if

print "any key = quit ..."
while inkey=""
  sleep 10
wend
if ts3client_stopConnection(ConnectionID,"i leave") then
  print "error: stopConnection() !"
end if
ts3client_freeMemory Identity

ts3client_destroyServerConnectionHandler ConnectionID
ts3client_destroyClientLib
sleep
